<template>
	<div class="list-page tickets-table">
		<h2 class="list-pageH2 wow fadeInLeft">{{ $t('tickets.table.title') }}</h2>
		<div class="box-table">
			<div class="table-head wow fadeInUp">
				<p class="text-p">#</p>
				<p class="text-p">{{ $t('tickets.table.user') }}</p>
				<p class="text-p">{{ $t('tickets.table.subject') }}</p>
				<p class="text-p">{{ $t('tickets.table.last_message') }}</p>
				<p class="text-p" style="width: 120px;"></p>
			</div>
			<div class="box-table--body wow fadeInUp" v-for="ticket in tickets">
				<p class="text-one">{{ ticket.id }}</p>
				<p class="text-one">{{ ticket.user.login }}</p>
				<p class="text-one">{{ ticket.subject }}</p>
				<p class="text-one">{{ ticket.last_message_at | formatDate }}</p>
				<div class="box__body--right">
					<router-link :to="route('tickets_show', {id: ticket.id})">
						<svg class="edit">
							<use xlink:href="/img/sprite.svg#edit"/>
						</svg>
					</router-link>
					<svg class="delete" @click="deleteTicket(ticket.id)">
						<use xlink:href="/img/sprite.svg#cancel-button"/>
					</svg>
				</div>
			</div>
			<paginator
				:current-page="currentPage"
				:last-page="lastPage"
				:per-page="perPage"
				:items-count="total"
				@page-changed="setPage"
			/>
		</div>
	</div>
</template>

<script>
import route from "../../mixins/route";
import { mapGetters } from 'vuex';
import dayjs from 'dayjs';

export default {
	name: "TicketsTable",
	mixins: [route],
	data() {
		return {
			currentPage: 0,
			lastPage: 0,
			perPage: 0,
			total: 0,
			page: 1,
			tickets: [],
		}
	},
	computed: {
		...mapGetters([
			'axios',
			'locale'
		])
	},
	filters: {
		formatDate(value){
			return dayjs(value).format('DD.MM HH:mm')
		}
	},
	methods: {
		submit() {
			this.axios.get(`tickets`, {
				params: {
					page: this.page,
				}
			})
				.then(resp => resp.data)
				.then(tickets => {
					console.log(tickets);
					this.currentPage = tickets.current_page;
					this.lastPage = tickets.last_page;
					this.perPage = tickets.per_page;
					this.total = tickets.total;
					this.tickets = tickets.data;
				});
		},
		deleteTicket(id) {
			this.axios
				.post(`tickets/${id}/delete`)
				.then(resp => resp.data)
				.then(data => {
					if ('success' === data.status) {
						this.$swal('Тикет удален').then(() => {
							this.submit();
						});
					} else {
						this.$swal(this.$t('ui.error'), '', 'error')
					}
				});
		},
		setPage(page) {
			this.page = page;
			this.submit();
		},
	},
	mounted() {
		this.submit();
	},
}
</script>

<style scoped lang="scss">
.tickets-table .box-table .table-head{
	justify-content: space-between;
	padding: 0 36px;

	.text-p{
		flex: 1;
		margin: 1em 0;
	}
	.text-p:last-of-type{
		flex: none
	}
}
.text-one{
	flex: 1;
}
@media(max-width: 616px) {
	.tickets-table .box-table .table-head .text-p{
		margin: 1em 10px 1em 0;
	}
}
</style>
